"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = DataTableExample;

var _max2 = _interopRequireDefault(require("lodash/max"));

var _map2 = _interopRequireDefault(require("lodash/map"));

var _react = _interopRequireDefault(require("react"));

var _example = require("../../utils/example");

var _Button = _interopRequireDefault(require("../Button"));

var _ = _interopRequireDefault(require("."));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var data = [{
  name: 'Bob',
  email: 'a@weave.works'
}, {
  name: 'Albert',
  // Notice the emails are inverted to test sorting by this field
  email: 'b@weave.works'
}];
var nestedData = [{
  workloadId: 'default:deployment/myworkload',
  containers: [{
    name: 'nginx',
    behind: '4'
  }, {
    name: 'redis',
    behind: '1'
  }, {
    name: 'envoy',
    behind: '2'
  }]
}, {
  workloadId: 'default:deployment/helloworld',
  containers: [{
    name: 'helloworld',
    behind: '2'
  }]
}];

function DataTableExample() {
  return _react.default.createElement("div", null, _react.default.createElement(_example.Example, null, _react.default.createElement("h3", null, "Default Table"), _react.default.createElement(_.default, {
    data: data,
    columns: [{
      value: 'name',
      label: 'Name'
    }, {
      value: 'email',
      label: 'Email'
    }]
  }, function (rows) {
    return (0, _map2.default)(rows, function (r) {
      return _react.default.createElement("tr", {
        key: r.email
      }, _react.default.createElement("td", null, r.name), _react.default.createElement("td", null, r.email));
    });
  })), _react.default.createElement(_example.Example, null, _react.default.createElement("h3", null, "Nested Table"), _react.default.createElement(_.default, {
    nested: true,
    data: nestedData,
    sortBy: "workloadId",
    sortOrder: "asc",
    columns: [{
      value: 'workloadId',
      label: 'Workload'
    }, {
      value: 'containers',
      label: 'Containers'
    }, {
      value: 'behind',
      label: 'Behind'
    }],
    sortOverrides: {
      behind: function behind(row) {
        return (0, _max2.default)((0, _map2.default)(row.containers, function (c) {
          return c.behind;
        }));
      }
    }
  }, function (rows) {
    return (0, _map2.default)(rows, function (r) {
      return _react.default.createElement("tbody", {
        key: r.workloadId
      }, (0, _map2.default)(r.containers, function (c, i) {
        return _react.default.createElement("tr", {
          key: c.name
        }, i === 0 && _react.default.createElement("td", {
          rowSpan: r.containers.length
        }, r.workloadId), _react.default.createElement("td", null, c.name), _react.default.createElement("td", null, c.behind));
      }));
    });
  })), _react.default.createElement(_example.Example, null, _react.default.createElement("h3", null, "With extra headers"), _react.default.createElement(_.default, {
    data: data,
    columns: [{
      value: 'name',
      label: 'Name'
    }, {
      value: 'email',
      label: 'Email'
    }],
    extraHeaders: [_react.default.createElement(_Button.default, null, "Extra Header")]
  }, function (rows) {
    return (0, _map2.default)(rows, function (r) {
      return _react.default.createElement("tr", {
        key: r.email
      }, _react.default.createElement("td", null, r.name), _react.default.createElement("td", null, r.email));
    });
  })), _react.default.createElement(_example.Example, null, _react.default.createElement("h3", null, "Flush Table"), _react.default.createElement(_.default, {
    data: data,
    flush: true,
    columns: [{
      value: 'name',
      label: 'Name'
    }, {
      value: 'email',
      label: 'Email'
    }]
  }, function (rows) {
    return (0, _map2.default)(rows, function (r) {
      return _react.default.createElement("tr", {
        key: r.email
      }, _react.default.createElement("td", null, r.name), _react.default.createElement("td", null, r.email));
    });
  })));
}