"use strict";

var _react = _interopRequireDefault(require("react"));

var _reactTestRenderer = _interopRequireDefault(require("react-test-renderer"));

require("jest-styled-components");

var _theme = require("../../utils/theme");

var _Dropdown = _interopRequireDefault(require("./Dropdown"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

describe('<Dropdown />', function () {
  var items = [{
    value: 'first-thing',
    label: 'First Thing'
  }, {
    value: 'second-thing',
    label: 'Second Thing'
  }, {
    value: 'third-thing',
    label: 'Super long thing, this should get truncated'
  }];
  describe('snapshots', function () {
    it('renders default', function () {
      var tree = _reactTestRenderer.default.create((0, _theme.withTheme)(_react.default.createElement(_Dropdown.default, {
        items: items
      }))).toJSON();

      expect(tree).toMatchSnapshot();
    });
    it('renders a placeholder', function () {
      var tree = _reactTestRenderer.default.create((0, _theme.withTheme)(_react.default.createElement(_Dropdown.default, {
        placeholder: "Select an item",
        items: items
      }))).toJSON();

      expect(tree).toMatchSnapshot();
    });
  });
  it('is extendable', function () {
    // Make sure a styled-component gets exported
    expect(_typeof(_Dropdown.default.extend)).toEqual('function');
    expect(_Dropdown.default.displayName).toEqual('Dropdown');
  });
});