"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _shuffle2 = _interopRequireDefault(require("lodash/shuffle"));

var _last2 = _interopRequireDefault(require("lodash/last"));

var _initial2 = _interopRequireDefault(require("lodash/initial"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _example = require("../../utils/example");

var _GraphNode = _interopRequireDefault(require("../GraphNode"));

var _GraphEdge = _interopRequireDefault(require("./GraphEdge"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var A = {
  x: 100,
  y: 50
};
var B = {
  x: 30,
  y: 100
};
var C = {
  x: 170,
  y: 200
};
var D = {
  x: 100,
  y: 250
};

var CheckBox = _styledComponents.default.input.attrs({
  type: 'checkbox'
}).withConfig({
  displayName: "example__CheckBox",
  componentId: "sc-1bjvwh5-0"
})(["margin-right:10px;margin-bottom:30px;"]);

var TextInput = _styledComponents.default.input.attrs({
  type: 'input'
}).withConfig({
  displayName: "example__TextInput",
  componentId: "sc-1bjvwh5-1"
})(["text-align:right;margin-left:30px;margin-right:5px;width:40px;"]);

var GraphEdgeContainer = function GraphEdgeContainer(_ref) {
  var children = _ref.children;
  return _react.default.createElement("svg", {
    width: "200px",
    height: "300px"
  }, children);
};

var TranslatedNode = function TranslatedNode(_ref2) {
  var name = _ref2.name,
      point = _ref2.point,
      props = _objectWithoutProperties(_ref2, ["name", "point"]);

  return _react.default.createElement("g", {
    key: name,
    transform: "translate(".concat(point.x, ", ").concat(point.y, ")")
  }, _react.default.createElement(_GraphNode.default, _extends({
    shape: "circle",
    id: name,
    label: name,
    size: 50
  }, props)));
};

var GraphNodeExample =
/*#__PURE__*/
function (_React$Component) {
  _inherits(GraphNodeExample, _React$Component);

  function GraphNodeExample() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, GraphNodeExample);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(GraphNodeExample)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      thickness: 1,
      arrowOffset: 28,
      contrastMode: false,
      highlightedEdgeId: null,
      edges: [{
        id: 'straight-edge',
        waypoints: [A, D]
      }, {
        id: 'curvy-edge',
        waypoints: [A, B, C, D],
        withArrow: true
      }, {
        id: 'dotted-edge',
        waypoints: [A, B, C, D],
        isDotted: true
      }, {
        id: 'animated-edge',
        waypoints: [A, C, B, D],
        withArrow: true,
        isAnimated: true
      }]
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleContrastModeChange", function () {
      _this.setState({
        contrastMode: !_this.state.contrastMode
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleThicknessChange", function (ev) {
      _this.setState({
        thickness: Number(ev.target.value)
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleArrowOffsetChange", function (ev) {
      _this.setState({
        arrowOffset: Number(ev.target.value)
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleEdgeMouseEnter", function (highlightedEdgeId) {
      _this.setState({
        highlightedEdgeId: highlightedEdgeId
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleEdgeMouseLeave", function () {
      _this.setState({
        highlightedEdgeId: null
      });
    });

    return _this;
  }

  _createClass(GraphNodeExample, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      this.timer = setInterval(function () {
        _this2.setState({
          edges: _toConsumableArray((0, _initial2.default)(_this2.state.edges)).concat([_objectSpread({}, (0, _last2.default)(_this2.state.edges), {
            waypoints: [A].concat(_toConsumableArray((0, _shuffle2.default)([B, C])), [D])
          })])
        });
      }, 2000);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearInterval(this.timer);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      return _react.default.createElement("div", null, _react.default.createElement(CheckBox, {
        checked: this.state.contrastMode,
        onChange: this.handleContrastModeChange
      }), "Contrast Mode", _react.default.createElement(TextInput, {
        value: this.state.thickness,
        onChange: this.handleThicknessChange
      }), "px - edge thickness", _react.default.createElement(TextInput, {
        value: this.state.arrowOffset,
        onChange: this.handleArrowOffsetChange
      }), "px - arrow offset", _react.default.createElement(_example.Example, null, this.state.edges.map(function (edge) {
        return _react.default.createElement(GraphEdgeContainer, {
          key: edge.id
        }, _react.default.createElement(_GraphEdge.default, {
          id: edge.id,
          waypoints: edge.waypoints,
          withArrow: edge.withArrow || edge.id === _this3.state.highlightedEdgeId,
          highlighted: edge.id === _this3.state.highlightedEdgeId,
          isDotted: edge.isDotted,
          isAnimated: edge.isAnimated,
          thickness: _this3.state.thickness,
          arrowOffset: _this3.state.arrowOffset,
          contrastMode: _this3.state.contrastMode,
          onMouseEnter: _this3.handleEdgeMouseEnter,
          onMouseLeave: _this3.handleEdgeMouseLeave
        }), _react.default.createElement(TranslatedNode, {
          name: "source",
          point: A,
          contrastMode: _this3.state.contrastMode
        }), _react.default.createElement(TranslatedNode, {
          name: "target",
          point: D,
          contrastMode: _this3.state.contrastMode
        }));
      })));
    }
  }]);

  return GraphNodeExample;
}(_react.default.Component);

exports.default = GraphNodeExample;