"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _reactTestRenderer = _interopRequireDefault(require("react-test-renderer"));

require("jest-styled-components");

var _theme = require("../../utils/theme");

var _MatchedText = _interopRequireDefault(require("./MatchedText"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var text = 'Rerum molestiae omnis in laudantium.';
var matches = ['um', 'Re'];
describe('<MatchedText />', function () {
  describe('snapshots', function () {
    it('renders default', function () {
      var tree = _reactTestRenderer.default.create((0, _theme.withTheme)(_react.default.createElement(_MatchedText.default, {
        text: text,
        matches: matches
      }))).toJSON();

      expect(tree).toMatchSnapshot();
    });
  });
  it('chunks properly', function () {
    var component = (0, _enzyme.shallow)(_react.default.createElement(_MatchedText.default, {
      text: text,
      matches: matches
    }));
    expect(component.state().chunks).toEqual([{
      text: 'Re',
      matched: true
    }, {
      text: 'r',
      matched: false
    }, {
      text: 'um',
      matched: true
    }, {
      text: ' molestiae omnis in laudanti',
      matched: false
    }, {
      text: 'um',
      matched: true
    }, {
      text: '.',
      matched: false
    }]);
  });
});