"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _theme = require("../../utils/theme");

var _Menu = _interopRequireDefault(require("./Menu"));

var _MenuItem = _interopRequireDefault(require("./MenuItem"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<Menu />', function () {
  it('return the menu text onClick', function () {
    var spy = jest.fn();
    var menu = (0, _enzyme.mount)((0, _theme.withTheme)(_react.default.createElement(_Menu.default, null, _react.default.createElement(_MenuItem.default, {
      onClick: spy,
      text: "Item 1"
    }))));
    menu.find(_MenuItem.default).simulate('click');
    expect(spy).toBeCalledWith('Item 1');
  });
  it('should show the active menu item', function () {
    var menu = (0, _enzyme.mount)((0, _theme.withTheme)(_react.default.createElement(_Menu.default, null, _react.default.createElement(_MenuItem.default, {
      text: "Item 1"
    }), _react.default.createElement(_MenuItem.default, {
      active: true,
      text: "Item 2"
    }))));
    expect(menu.find('.weave-menu-item').last().hasClass('menu-item-active')).toBe(true);
  });
});