"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _noop2 = _interopRequireDefault(require("lodash/noop"));

var _includes2 = _interopRequireDefault(require("lodash/includes"));

var _filter2 = _interopRequireDefault(require("lodash/filter"));

var _map2 = _interopRequireDefault(require("lodash/map"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _example = require("../../utils/example");

var _Search = _interopRequireDefault(require("./Search"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  width: 300px;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var List = function List(_ref) {
  var items = _ref.items,
      text = _ref.text,
      terms = _ref.terms;
  var list = text.length > 0 || terms.length > 0 ? (0, _filter2.default)(items, function (i) {
    return text === i || (0, _includes2.default)(terms, i);
  }) : items;
  return _react.default.createElement("ul", null, (0, _map2.default)(list, function (item) {
    return _react.default.createElement("li", {
      key: item
    }, item);
  }));
};

var Styled = function Styled(component) {
  return (0, _styledComponents.default)(component).withConfig({
    displayName: "example",
    componentId: "ogry5a-0"
  })(["", "{margin-bottom:96px;}"], _example.Example);
};

var NarrowSearch = _Search.default.extend(_templateObject());

var SearchExample =
/*#__PURE__*/
function (_React$Component) {
  _inherits(SearchExample, _React$Component);

  function SearchExample() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, SearchExample);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(SearchExample)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      queries: {
        normal: {
          text: '',
          terms: []
        },
        filters: {
          text: '',
          terms: []
        }
      },
      query1: '',
      query2: '',
      query3: '',
      pinnedTerms1: [],
      pinnedTerms2: [],
      pinnedTerms3: ['foo:bar', 'is:automated']
    });

    return _this;
  }

  _createClass(SearchExample, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react.default.createElement("div", {
        className: this.props.className
      }, _react.default.createElement(_example.Example, null, _react.default.createElement("h3", null, "Normal"), _react.default.createElement(_Search.default, {
        query: this.state.query1,
        pinnedTerms: this.state.pinnedTerms1,
        onChange: function onChange(query1, pinnedTerms1) {
          return _this2.setState({
            query1: query1,
            pinnedTerms1: pinnedTerms1,
            queries: _objectSpread({}, _this2.state.queries, {
              normal: {
                text: query1,
                terms: pinnedTerms1
              }
            })
          });
        }
      }), _react.default.createElement(List, {
        items: ['red', 'green', 'blue'],
        terms: this.state.queries.normal.terms,
        text: this.state.queries.normal.text
      })), _react.default.createElement(_example.Example, null, _react.default.createElement("h3", null, "With filters"), _react.default.createElement(NarrowSearch, {
        query: this.state.query2,
        pinnedTerms: this.state.pinnedTerms2,
        onFilterSelect: function onFilterSelect(value) {
          return _this2.setState({
            pinnedTerms2: [value],
            queries: _objectSpread({}, _this2.state.queries, {
              filters: {
                text: '',
                terms: [value]
              }
            })
          });
        },
        onChange: function onChange(query2, pinnedTerms2) {
          return _this2.setState({
            query2: query2,
            pinnedTerms2: pinnedTerms2,
            queries: _objectSpread({}, _this2.state.queries, {
              filters: {
                text: query2,
                terms: pinnedTerms2
              }
            })
          });
        },
        filters: [{
          value: 'red',
          label: 'Red'
        }, {
          value: 'blue',
          label: 'Blublublublublublublublublublublu'
        }]
      }), _react.default.createElement(List, {
        items: ['red', 'green', 'blue'],
        text: this.state.queries.filters.text,
        terms: this.state.queries.filters.terms
      })), _react.default.createElement(_example.Example, null, _react.default.createElement("h3", null, "With an initial query and filters"), _react.default.createElement(_Search.default, {
        query: this.state.query3,
        pinnedTerms: this.state.pinnedTerms3,
        onChange: function onChange(query3, pinnedTerms3) {
          return _this2.setState({
            query3: query3,
            pinnedTerms3: pinnedTerms3
          });
        },
        onFilterSelect: function onFilterSelect(value) {
          return _this2.setState({
            pinnedTerms3: [value]
          });
        },
        filters: [{
          value: 'is:automated',
          label: 'Automated'
        }, {
          value: 'is:locked',
          label: 'Locked'
        }]
      })), _react.default.createElement(_example.Example, null, _react.default.createElement("h3", null, "Disabled"), _react.default.createElement(_Search.default, {
        disabled: true,
        query: "",
        pinnedTerms: [],
        filters: [{
          value: 'red',
          label: 'Red'
        }],
        onChange: _noop2.default
      })), _react.default.createElement(_example.Example, null, _react.default.createElement("h3", null, "Disabled with a query and pinnedTerms"), _react.default.createElement(_Search.default, {
        disabled: true,
        query: "prom",
        pinnedTerms: this.state.pinnedTerms3,
        onChange: _noop2.default
      })));
    }
  }]);

  return SearchExample;
}(_react.default.Component);

var _default = Styled(SearchExample);

exports.default = _default;