"use strict";

var _each2 = _interopRequireDefault(require("lodash/each"));

var _fs = _interopRequireDefault(require("fs"));

var _expect = _interopRequireDefault(require("expect"));

var WeaveComponents = _interopRequireWildcard(require("./index"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable import/no-duplicates, no-duplicate-imports */
function getFiles(path) {
  return _fs.default.readdirSync(path).filter(function (d) {
    return !/^\.|index|example|test/.test(d);
  });
}

describe('index', function () {
  it('should contain the components', function () {
    (0, _expect.default)(WeaveComponents).toExist();
    (0, _expect.default)(WeaveComponents.Button).toExist();
  });
  it('should contain all components from a directory', function () {
    (0, _expect.default)(WeaveComponents.Grid).toExist();
    (0, _expect.default)(WeaveComponents.GridColumn).toExist();
  });
  it('exports a non-default component', function () {
    (0, _expect.default)(WeaveComponents.MenuItem).toExist();
  });
  it('should export all the components from "src/components"', function () {
    var componentsDir = './src/components';
    var files = getFiles(componentsDir);
    (0, _each2.default)(files, function (f) {
      // Skip private components.
      if (f[0] !== '_') {
        (0, _expect.default)(WeaveComponents[f]).toExist("".concat(f, " module is missing. Did you export it from \"src/components/index.js\"?"));
      }
    });
  });
});