"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.atoms = void 0;

var _polished = require("polished");

var _colors = require("./colors");

// component-specific
var atoms = {
  Alert: {
    default: {
      color: _colors.colors.black,
      background: _colors.colors.gray50,
      borderColor: _colors.colors.gray200
    },
    info: {
      color: _colors.colors.white,
      background: _colors.colors.blue600,
      borderColor: _colors.colors.blue800
    },
    success: {
      color: _colors.colors.white,
      background: _colors.colors.green500,
      borderColor: (0, _polished.darken)(0.15, _colors.colors.green500)
    },
    warning: {
      color: _colors.colors.white,
      background: _colors.colors.yellow500,
      borderColor: (0, _polished.darken)(0.15, _colors.colors.yellow500)
    },
    error: {
      color: _colors.colors.white,
      background: _colors.colors.orange600,
      borderColor: _colors.colors.orange800
    }
  },
  Button: {
    default: {
      color: _colors.colors.black,
      background: _colors.colors.white,
      hoverColor: _colors.colors.purple800,
      hoverBackground: _colors.colors.gray50
    },
    primary: {
      color: _colors.colors.white,
      background: _colors.colors.blue700,
      hoverColor: _colors.colors.white,
      hoverBackground: _colors.colors.blue800
    },
    danger: {
      color: _colors.colors.white,
      background: _colors.colors.orange600,
      hoverColor: _colors.colors.white,
      hoverBackground: _colors.colors.orange700
    },
    disabled: {
      color: _colors.colors.gray600,
      background: _colors.colors.gray50,
      hoverColor: _colors.colors.gray600,
      hoverBackground: _colors.colors.gray50
    }
  }
};
exports.atoms = atoms;